/*
 * WHOIS.CMD
 *
 * Lookup host in registry
 */

parse arg targethost server .

/*
 * Serverlist at http://101domainname.biz/country_whois_server.php
 */

/* Minimal serverlist - add your own! */
srvlist.  = '';
rc=WhoisServer('com','whois.networksolutions.com')
rc=WhoisServer('net','whois.networksolutions.com')
rc=WhoisServer('org','whois.networksolutions.com')
rc=WhoisServer('dk','whois.dk-hostmaster.dk')

crlf = d2c(13) || d2c(10)

rc = RxFuncAdd('SockLoadFuncs','rxSock','SockLoadFuncs')
rc = SockLoadFuncs(dummy);

rc = SockInit();
if rc\=0 then do;
  say "SockInit rc:" rc;
  exit 16;
end;
host = "host.!";

if server = '' then do;
  /* lookup by top-level domain */
  tld = targethost;
  do while (pos('.',tld)\=0)
    parse var tld pre'.'tld .;
  end;
  server = srvlist.tld;
  if server='' then do;
    Say 'Unable to determine WHOIS server. Using default';
		server = 'whois.networksolutions.com'
  end;
end;

rc = SockGetHostByName(server,host);

if (rc\=1) then do;
  Say "SockGetHostByName error";
  Exit 16;
end;

server = host.!addr;

sock = SockSocket("AF_INET","SOCK_STREAM","IPPROTO_TCP")
if (sock = -1) then do;
   say "Error opening socket:" errno
   exit 16
end

server.!family = "AF_INET"
server.!port   = 43
server.!addr   = server

rc = SockConnect(sock,"server.!")

if (rc = -1) then
   Error(sock,rc,"Error connecting to "server" :" errno)

trc = SendMessage(sock,targethost)

line. = 0;

trc = GetResponse(sock)

do i = 1 to line.0;
  say line.i;
end;

exit;

/*------------------------------------------------------------------
 * get a response from the server
 *------------------------------------------------------------------*/
GetResponse:     procedure expose line.
   sock = arg(1)

   crlf = d2c(13) || d2c(10)
   lf = d2c(10);

	 buf = '';
   do until (data='');
      rc = SockRecv(sock,"data",8000)
      buf = buf || data
   end

   lineno = 0;
	 do while (buf\='')
	   p = pos(crlf,buf);
	   if (p\=0) then do;
	      l = substr(buf,1,p-1);
	      buf = substr(buf,p+2);
	   end;
	   else do;
	      p = pos(lf,buf);
	      if (p\=0) then do;
	        l = substr(buf,1,p-1);
	        buf = substr(buf,p+1);
	      end;
	      else do;
	        l = buf;
	        buf = '';
	      end;
	   end;
     lineno = lineno + 1
     line.lineno = l;
   end;

   line.0 = lineno;

   return ""

/*------------------------------------------------------------------
 * send a string to the server
 *------------------------------------------------------------------*/
SendMessage:     procedure expose !.
   sock = arg(1)
   data = arg(2) || d2c(13) || d2c(10)

   len = length(data)
   do while (len > 0)

      len = SockSend(sock,data);
      /* say 'Returncode: ' len   */
      /* say 'Errorcode:  ' errno */
      /*
      if (errno <> 0) then
         Error(-1,rc,"Error sending data to server.")
      */
      if (len <= 0) then
         Error(sock,100,"Server closed the connection.")

      data = substr(data,len+1)
      len  = length(data)
   end

   return i

WhoisServer: procedure expose srvlist.
	 tld = arg(1);
	 srv = arg(2);
	
	 srvlist.tld = srv;
	 return 0;

Error: procedure
   sock = arg(1)
   retc = arg(2)
   msg  = arg(3)

   if (sock <> -1) then
      rc = SockSoClose(sock)

   say msg

   exit retc


