/*
 * Extended DIR
 */

  Recurse=0;
  Longnames=0;

  parse upper arg arg0 rest;
  do while(SUBSTR(arg0,1,1)='/');
    if SUBSTR(arg0,2,1)='S' then Recurse=1;
    else if SUBSTR(arg0,2,1)='L' then Longnames=1;
    else do;
      say "USAGE: XDIR [options] [pattern]"
      say "       Options: /S: Recurse subdirectories"
      say "                /L: Long filenames (full path)"
      exit;
    end;
    parse upper var rest arg0 rest;
  end;
  pattern=arg0;
  if pattern='' then pattern='*';

  /* Get utility funcs */
  call RxFuncAdd 'SysLoadFuncs', 'RexxUtil', 'SysLoadFuncs';
  call SysLoadFuncs;

  /* get file list */
  searchtype='T';
  if Recurse=1 then
    searchtype = 'S'searchtype;
  Rc = SysFileTree(pattern,files,searchtype);

  if rc=0 then do;
    do i = 1 to files.0;
      parse var files.i fdatetime fsize fattr ffname;
      parse var fdatetime fyear2'/'fmonth'/'fday'/'fhour'/'fminute
      if fyear2 > '70' then
        fyear = 1900 + fyear2
      else
        fyear = 2000 + fyear2;

      if SUBSTR(fattr,2,1)='D' then
        sz = '<DIR>'
      else
        sz = fsize;
      if Longnames=0 then ffname = FILESPEC("name",ffname);
      say fyear'-'RIGHT(fmonth,2,'0')'-'RIGHT(fday,2,'0') fhour':'fminute RIGHT(sz,6) ffname;
    end;
  end;

  if Rc <> 0 then
    say 'Error: Rc='Rc;

exit;
